//
//  GLVisualizerComplexSceneObjectPart.m
//  SoundVisualizer
//
//  Created by mac-admin on 02/01/2013.
//  Copyright (c) 2013 Mike Dutka. All rights reserved.
//

#import "GLVisualizerComplexSceneObjectPart.h"

@implementation GLVisualizerComplexSceneObjectPart
@synthesize meshObject, transform, parrent, childParts, baseTransform;

- (id)init
{
    self = [super init];
    if (self) {
        meshObject = [[[self mesh] alloc] init];
        transform = [[GLTransformation alloc] init];
        
        [self buildObject];
    }
    return self;
}

-(void)buildObject{
    childParts = [[NSMutableArray alloc] init];
    
    //add child parts here if any exists
}

-(void)addChildPart:(GLVisualizerComplexSceneObjectPart *)child{
    [childParts addObject:child];
}

-(GLTransformation*)baseTransform{
    if(baseTransform == nil){
        baseTransform = [[self baseObjectTransformation] retain];
    }
    return baseTransform;
}

-(GLTransformation*)baseObjectTransformation{
    return [[[GLTransformation alloc] init] autorelease];
}

- (Class)mesh{
    return [GLVisualizerMesh class];
}

-(void)updateWithData:(NSObject*)data{
    //update transformation data
    
    //sent update data to child parts
    [childParts makeObjectsPerformSelector:@selector(updateWithData:) withObject:data];
}

-(void)renderWholeTree{
    glPushMatrix();
    [transform applyWithBase:self.baseTransform];
    [meshObject render];
    [childParts makeObjectsPerformSelector:@selector(renderWholeTree)];
    glPopMatrix();
}

-(void)dealloc{
    [meshObject release];
    [transform release];
    [baseTransform release];
    
    [parrent release];
    [childParts release];
    
    [super dealloc];
}
@end
